using System;
using System.Reflection;
using System.Xml;

namespace FlexiGen {

public abstract class SourceBase : ISource, IInitializeable {


#region "Static stuff"

#endregion


#region "Encapsulation"
private string m_Name;
private string m_ParserTypeName;
private ITemplateParser m_Parser;
private Generator m_Generator;
#endregion


#region "Init/Fin"
public SourceBase() {

}
#endregion


#region "Event handlers"

#endregion


#region "Event raisers"

#endregion


#region "Properties"
public string Name{
	get{
		return m_Name;
	}
}
public string ParserTypeName{
	get{
		return m_ParserTypeName;
	}
}
public Generator Generator{
	get{
		return m_Generator;
	}
}
#endregion


#region "Methods"
public virtual void Initialize(Generator generator, XmlElement xe){
	m_Generator = generator;
	m_Name = generator.FindAttribute(xe, "name");
	m_ParserTypeName = generator.FindAttribute(xe, "parserType");
}
public virtual ITemplateParser GetParser(){
	if(m_Parser == null){
		m_Parser = (ITemplateParser) m_Generator.CreateInstance(m_ParserTypeName, typeof(ITemplateParser));
	}
	return m_Parser;
}
public abstract string GetTemplateText();
#endregion


#region "Helpers"

#endregion


} // end class SourceBase

} // end namespace FlexiGen
