using System;
using System.Text;
using System.Collections;

namespace FlexiGen {

public class StandardTemplateParser : ITemplateParser {


#region "Static stuff"

#endregion


#region "Encapsulation"

#endregion


#region "Init/Fin"
public StandardTemplateParser() {

}
#endregion


#region "Event handlers"

#endregion


#region "Event raisers"

#endregion


#region "Properties"

#endregion


#region "Methods"
public string Parse(string text, ITreeNode node) {
  
  bool escaped = false;
  StringBuilder buffer = new StringBuilder(text.Length);
  int iDollar = -1;
  Hashtable htable = new Hashtable();
  
  for(int i = 0; i < text.Length; i++) {
    char c = text[i];
    
    if(c == '$' && iDollar == -1)
	{
		if(escaped)
		{
			buffer.Append(c);
			escaped = false;
		}
		else
		{
			iDollar = i;
		}     
    }
    else if(char.IsWhiteSpace(c) && iDollar != -1)
    {
		string name = text.Substring(iDollar + 1, i - iDollar -1);
		this.ProcessVariable(buffer, htable, name, node);
		buffer.Append(c);
		iDollar = -1;
    }
    else if(c == '\\' && iDollar == -1)
    {
		if (escaped == true)
	       	buffer.Append(c);
	
		escaped = !escaped;
    }
    else if(iDollar == -1)
    {
      buffer.Append(c);
    }
  }
  if(iDollar != -1)
  {
     string name = text.Substring(iDollar + 1);
     this.ProcessVariable(buffer, htable, name, node);
  } 
  
  return buffer.ToString();
}
private void ProcessVariable(StringBuilder buffer, Hashtable htable, string name, ITreeNode node){
	if(!htable.ContainsKey(name))
	{
		string value = node.GetValue(name);
		if(value == null)
		{
			throw new FlexiGenTemplateException("Value '" + name + "' not found.");
		}
		else
		{
			htable.Add(name, value);
			buffer.Append(value);
		}
	}
	else
	{
		buffer.Append(htable[name]);
	}
}
#endregion


#region "Helpers"

#endregion


} // end class StandardTemplateParser

} // end namespace FlexiGen
