// <clown> csc.exe /debug+ /r:FlexiGen.dll TestFlexiGen.cs </clown>

using System;
using System.Xml;
using FlexiGen;

namespace TestFlexiGen{

public class Test {

    public static void Main(string[] args){

        TestNode root = new DatabaseNode("root");
        root.AddChild(new TableNode("first"));
        root.AddChild(new TableNode("second"));
        ((TestNode)root.FirstChild).AddChild(new ColumnNode("uno"));
        ((TestNode)root.FirstChild).AddChild(new ColumnNode("dos"));
        root.AddChild(new ViewNode("erster"));
        root.AddChild(new ViewNode("zweiter"));

        Generator gator = new Generator("TestFlexiGen.xml");
        //gator.FilterHandler = new FilterCallback(Test.ApplyFilter);

        gator.Generate(root);
    }

    private static bool ApplyFilter(XmlElement xe, ITreeNode node){
        return false;
    }

} // class Test

public abstract class TestNode : ITreeNode {

    private string m_Name;
    private TestNode m_Parent;
    private TestNode m_FirstChild;
    private TestNode m_Next;

    public TestNode(string sName) : base(){
        m_Name = sName;
    }

    public ITreeNode Parent{
        get{
            return m_Parent;
        }
    }

    public ITreeNode FirstChild{
        get{
            return m_FirstChild;
        }
    }

    public ITreeNode Next{
        get{
            return m_Next;
        }
    }

    public abstract string NodeType{get;}

    public string Name{
        get{
            return m_Name;
        }
    }

    public virtual string GetValue(string param){
        switch(param){
            case "name":
                return this.Name;
            default:
                return null;
        }
    }

    public override string ToString(){
        return this.NodeType + " (" + this.Name + ")";
    }

    public void AddChild(TestNode node){
        if(m_FirstChild == null){
            m_FirstChild = node;
        }else{
            ITreeNode child = m_FirstChild;
            while(child != null && child.Next != null){
                child = child.Next;
            }
            ((TestNode)child).m_Next = (TestNode) node;
        }
        node.m_Parent = this;
    }

} // class TestNode

public class DatabaseNode : TestNode {

    public DatabaseNode(string sName) : base(sName){
        // OK
    }

    public override string NodeType{
        get{
            return "database";
        }
    }

    public override string GetValue(string param){
        switch(param){
            case "qualifier":
                return "db2e";
            default:
                return base.GetValue(param);
        }
    }

} // class DatabaseNode

public class TableNode : TestNode {

    public TableNode(string sName) : base(sName){
        // OK
    }

    public override string NodeType{
        get{
            return "table";
        }
    }

} // class TableNode

public class ViewNode : TestNode {

    public ViewNode(string sName) : base(sName){
        // OK
    }

    public override string NodeType{
        get{
            return "view";
        }
    }

} // class ViewNode

public class ColumnNode : TestNode {

    public ColumnNode(string sName) : base(sName){
        // OK
    }

    public override string NodeType{
        get{
            return "column";
        }
    }

    public override string GetValue(string param){
        switch(param){
            case "type":
                return "CHAR";
            case "nullable":
                return "1";
            case "length":
                return "15";
            case "scale":
                return "0";
            default:
                return base.GetValue(param);
        }
    }

} // class ColumnNode

} // namespace ' TestFlexiGen